package ns;

import java.io.Serializable;


public class TaskTimer implements Serializable{
    private static final long serialVersionUID=1;
    public long getStartTime() {
        return startTime;
    }
    public void stop(){
          stopTime=System.currentTimeMillis() ;
    }
    public String toString(){
        return getTimeTakenPrintout();
    }
    public String stopString(){
        stop();
        return toString();
    }
    private String getTimeTakenPrintout(){
        long t=stopTime-startTime;
        return formatMillis(t);
    }

    public String formatMillis(long t) {
        if(t<1000){
             return t+"ms";
        }
        else if (t<60000){
            return divide(t,1000,2)+"secs";//(t,t+"s";
        }
        else if(t<6000000){
            return divide(t,60000,2)+"mins";
        }
        else {
           return divide(t,3600000,2)+"hours";
        }
    }

    private long pow(long number,int power){
        for(int i=0;i<power;i++) number*=number;
        return number;
    }
    private String divide(long numerator, long denominator, int dps){
        long multiple=pow(10,dps);//(long)Math.pow(10,dps);
        long l = (numerator*multiple)/denominator;
        return String.valueOf(l/multiple)+getMantissaString(String.valueOf(l%multiple),dps);
    }
    private String getMantissaString(String s, int dps){
       if(s.length()>dps){
           s=s.substring(0,dps);
        }
        while(s.endsWith("0") && s.length()>0){
            s=s.substring(0,s.length()-1);
        }

        return s.length()==0?"":"."+s;
    }
    public TaskTimer() {
        startTime=System.currentTimeMillis() ;
    }

    private long startTime,stopTime;

}
