package uk.co.hcsoftware.images.gui;

import java.awt.event.KeyEvent;
import java.io.*;
import java.util.List;
import java.util.ArrayList;


/**
 * Title: QuickFiles
 * Copyright:    Copyright (c) 14-Dec-2005
 *
 * @author spurlinn
 */
public enum QuickFiles{
    F1("imagenames_f1", KeyEvent.VK_F1),F2("imagenames_f2", KeyEvent.VK_F2),F3("imagenames_f3", KeyEvent.VK_F3),F4("imagenames_f4", KeyEvent.VK_F4),F5("imagenames_f5", KeyEvent.VK_F5);
    private final int key;

    public File getFile() {
        return f;
    }

    public int getKey() {
        return key;
    }

    private final File f;
    QuickFiles(String s, int key){
        this.key = key;
        this.f = new File(s);
    }
    public void addName(String name) throws IOException {
        FileWriter fw = new FileWriter(f,true);
        fw.write(name+"\n");
        fw.close();
    }
    public int removeName(String filename) throws IOException {
        if(!f.exists()){
            return 0;
        }
        LineNumberReader lnr = new LineNumberReader(new FileReader(f));
        List<String> filenames = new ArrayList<String>(50);
        String line;
        int removed=0;
        while((line=lnr.readLine())!=null){
            if(!line.equals(filename)) filenames.add(line);
            else removed++;
        }
        lnr.close();
        FileWriter fw = new FileWriter(f,false);
        for(String fname: filenames){
            fw.write(fname+"\n");
        }
        fw.close();
        return removed ;
    }

}
