package uk.co.hcsoftware.images.gui.map;


import com.sun.media.jai.widget.DisplayJAI;
import ns.TaskTimer;
import org.apache.commons.cli.*;

import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;
import javax.media.jai.RenderedOp;
import javax.media.jai.TiledImage;
import javax.swing.*;
import java.awt.*;
import java.awt.geom.AffineTransform;
import java.awt.image.renderable.ParameterBlock;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;
import java.lang.reflect.Field;
import java.util.*;
import java.util.List;

public class MapBuddy {
    /*public static String getOsNameForSquare(int imageX, int imageY, int w, int h) {
        //first find the letters
       //  System.out.println("smallSquareSize = " + smallSquareSize);
        final int smallSquareCol = imageX==0?0:OS_GRID_WIDTH/imageX;
        final int smallSquareRo = imageY==0?0:OS_GRID_HEIGHT/imageY;
        System.out.println("smallSquareRo = " + smallSquareRo);
        System.out.println("smallSquareCol = " + smallSquareCol);
        int bigSquareCol=smallSquareCol/SQUARES[0].length;
        int bigSquareRo=smallSquareRo/SQUARES.length;

        bigSquareRo = SQUARES.length-bigSquareRo-1;
        return SQUARES[bigSquareRo][bigSquareCol];
    }*/
    private final List<OsSquare> squaresList;
    static final int SQUARE_SIZE=100 *1000;//metres 100km^2
    static final int smallSquareSize=SQUARE_SIZE/10;//metres == 10km
    private static final String[][] SQUARES = new String[][]{
        new String[]{"SV", "SW", "SX", "SY", "SZ", "TV", "TW"}
        , new String[]{"SQ", "SR", "SS", "ST", "SU", "TQ", "TR"}
        , new String[]{"SL", "SM", "SN", "SO", "SP", "TL", "TM"}
        , new String[]{"SF", "SG", "SH", "SJ", "SK", "TF", "TG"}
        , new String[]{"SA", "SB", "SC", "SD", "SE", "TA", "TB"}
        , new String[]{"NV", "NW", "NX", "NY", "NZ", "OV", "OW"}
        , new String[]{"NQ", "NR", "NS", "NT", "NU", "OQ", "OR"}
        , new String[]{"NL", "NM", "NN", "NO", "NP", "OL", "OM"}
        , new String[]{"NF", "NG", "NH", "NJ", "NK", "OF", "OG"}
        , new String[]{"NA", "NB", "NC", "ND", "NE", "OA", "OB"}
        , new String[]{"HV", "HW", "HX", "HY", "HZ", "JV", "JW"}
        , new String[]{"HQ", "HR", "HS", "HT", "HU", "JQ", "JR"}
        , new String[]{"HL", "HM", "HN", "HO", "HP", "JL", "JM"}
    };
     static final int OS_GRID_HEIGHT=SQUARE_SIZE*SQUARES.length;
    static final int OS_GRID_WIDTH=SQUARE_SIZE*SQUARES[0].length;

    public static final Option verbose = new Option("v","verbose",false,"print lots of output");
    public static final Option display = new Option("d","display",false,"display the map onscreen");
    public static final Option save = new Option("s",true,"save the map to a file");
    public static final Option border = new Option("b",true,"extra metres around bounding box to include in map");
    public static final Option postcodefile = new Option("p","postcodefile",true,"file with postcode-(x,y) mappings");
    public static final Option namefile = new Option("n","placenamefile",true,"file with name-(x,y) mappings");
    public static final Option mapsroot = new Option("r","mapsroot",true,"root directory under which maps can be found");

    private static final Options availableOptions = new Options();
    static{
        mapsroot.setRequired(true);

        try {
            Field[] fields = MapBuddy.class.getDeclaredFields();
            for (int i = 0; i < fields.length; i++) {
                Field field = fields[i];
                if(field.getType()==Option.class){ //all fields that are Option s
                    availableOptions.addOption((Option)field.get(null));
                }
            }
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }

        verbose.setRequired(false);
    }

    private static CommandLine cmd;


    private static void usage(){
        //  System.out.println(Arrays.asList(args));
        HelpFormatter formatter = new HelpFormatter();
        formatter.printHelp(80
                , MapBuddy.class.getName()+" [opts] point1 [point2.. n]"
                ,"splices map tiles to create a new map the area of which is the smallest rectangle" +
                " that containts all the points\n" +
                "points can be any one of: \n\tUK postcode (e.g. E14); \n\tLandranger grid (e.g. TQ300700); \n\tx,y coords in metres measured from bottom left of " +
                "UK (e.g. 530000,170000) (see -p option); name name in a mapref file (see -n option)"
                , availableOptions
                ,"Example:\n\tjava -jar "+MapBuddy.class.getName().substring(MapBuddy.class.getName().lastIndexOf('.')+1)
                +".jar -v E14 W5\n" +
                "generates a map with E14, W5 and all the points between"
                ,false
        );
    }
    public static void main(String[] args) {
        try {
            cmd = new GnuParser().parse(availableOptions,args);
            if(cmd.hasOption(verbose.getOpt())){
                Option[] opts = cmd.getOptions();
                StringBuffer sb = new StringBuffer();
                for (int i = 0; i < opts.length; i++) {
                    Option opt = opts[i];
                    sb.append(opt.getOpt()+"="+opt.getValue());
                    if(i+1<opts.length) sb.append(" ");
                }
                System.out.println("options: "+sb.toString());
            }
            //todo: check for -d or -s  if(cmd.geto)
            final String[] arguments = cmd.getArgs();
            if(arguments.length>0){
                MapBuddy mb =new MapBuddy();
                try {
        //1.get the points
        //2.get a rectangle relative to ORIGIN that contains all those points
        //3.(optionally) grow the rectangle by buffer
        //4.create a tiledimage from that rectangle
        //? set the clip to rectangle?
        //5.draw all the touched maps ( no need to sort)
                    List<Point> points = mb.getPoints(arguments);
                    Rectangle smallestBoundingBox = mb.getBoundingBoxOsMetres(points);
                    // boundingBoxImageMetres.grow(boundinBoxExtra,boundinBoxExtra);

                  //  List<OsSquare> l= mb.getSquaresContainingPoints(arguments);
                     List<OsSquare> l = mb.getSquaresInsideRectangle(smallestBoundingBox);
                     //smallestBoundingBox.y=

                    int boundingBoxExtra=0;
                    final String bval = cmd.getOptionValue(border.getOpt());
                    if(bval!=null){
                        boundingBoxExtra=Integer.parseInt(bval);
                    }

                    TaskTimer tt = new TaskTimer();

                //    Rectangle boundingBoxImageMetres = createBoundingBox(l, boundingBoxExtra);
                    PlanarImage pi = mb.createMap(l,smallestBoundingBox);


                    if(verbose()){
                        System.out.println(tt.stopString()+" to create map from "+l.size()+" files");
                    }
                    final String sval = cmd.getOptionValue(save.getOpt());
                    if(sval!=null){
                        String savefile=sval;
                        if(verbose()){
                            System.out.println("saving to "+savefile);
                        }
                        File f = new File(savefile);
                        ParameterBlock pb = new ParameterBlock();
                        pb.addSource(pi);
                        pb.add(f);
                        //  final String of = cmd.getOptionValue(outputFormat.getOpt(),"jpeg");
                        //   pb.add(of);
                        //   pb.add(null);
                        JAI.create("filestore", pb, null);
                        //    System.out.println("wrote file= " + outFile+ " took "+tt.stopString());

                    }
                    if (cmd.hasOption(display.getOpt())) {
                        DisplayJAI displayPanel = new DisplayJAI();
                        displayPanel.set(pi);
                        JFrame jf = new JFrame();
                        jf.add(new JScrollPane(displayPanel));
                        jf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
                        jf.setSize(800,600);
                        //jf.pack();
                        jf.setVisible(true);
                    }


                    return;
                } catch (CannotGetSquareException e) {
                    System.err.println("I couldn't find map point for reference="+e.getReference());
                    if (verbose()) {
                        e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
                    }
                } catch (InvalidSquareRefException e) {
                    System.err.println("I couldn't understand reference="+e.getReference());
                    if (verbose()) {
                        e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
                    }
                } catch (NoSuchMapFileException e) {
                    System.err.println("I couldn't find mapfile="+e.getFilename());
                }

            }
        }  catch(MissingOptionException e){
            System.err.println("Missing option(s): "+e.getMessage());
        } catch (ParseException e) {
            e.printStackTrace();
        }
        usage();
    }

    private List<OsSquare> getSquaresInsideRectangle(Rectangle smallestBoundingBox) {
        List<OsSquare> l = new ArrayList<OsSquare>();
        for(OsSquare ns:squaresList){
            if(ns.intersects(smallestBoundingBox)) l.add(ns);
        }
        return l;
    }

    private Rectangle getBoundingBoxOsMetres(List<Point> points) {
        // boundingBoxImageMetres=getImageBoundingBox(squares);
        int minX=Integer.MAX_VALUE,minY=Integer.MAX_VALUE,maxX=-1,maxY=-1;
        for(OsSquare ns:squaresList){
            for(Point p:points){
                if(ns.contains(p)){
                    final int x = ns.x;
                    final int imageY = ns.getImageY();
                    minX=Math.min(x,minX);
                    // System.out.println(ns.getName()+": "+x+"," + imageY+" w="+ns.width);
                    minY=Math.min(imageY,minY);
                    maxX=Math.max(ns.x+ns.width,maxX);
                    maxY=Math.max(ns.getImageY()+ns.height,maxY);
                }
            }
        }
        Rectangle boundingBoxImageMetres = new Rectangle(new Point(minX,minY));
        boundingBoxImageMetres.add(new Point(maxX,maxY));

        return boundingBoxImageMetres;
    }

    private List<Point> getPoints(String[] arguments) throws CannotGetSquareException,InvalidSquareRefException{
        List<Point> l = new ArrayList<Point>(arguments.length);
        for (int i = 0; i < arguments.length; i++) {
            String a = arguments[i];
            try {
                //first look in the namefile if it exists
                Point p = getPointForName(a);
                if(p!=null){
                    if(verbose()) System.out.println("found entry in name file="+p);
                    l.add(p);
                }
                else if(a.indexOf(',')!=-1){ //it's a x,y
                    if(verbose()) System.out.println(a+" is x,y coordinate");
                    String[] xy = a.split(",");
                    int x=Integer.parseInt(xy[0]);
                    int y=Integer.parseInt(xy[1]);
                    l.add(new Point(x,y));
                }
                else if(a.length()==8){ //it's a landranger
                    if(verbose()) System.out.println(a+" is landranger gridref");
                    final OsSquare square = getSquare(a);
                    l.add(new Point(square.x,square.y));
                }
                else{ //it's a postcode
                    if(verbose()) System.out.println(a+" is a postcode");
                    Point p1 = getPostcodeConverter().getXyMetres(a);
                    System.out.println("x,y = " + p1);
                    if(p1==null){
                        throw new CannotGetSquareException(null,"no square for postcode="+a);
                    }
                    l.add(p1);
                }
            } catch (NumberFormatException e) {
                throw new InvalidSquareRefException(e,a);
            } catch(ArrayIndexOutOfBoundsException e){
                throw new InvalidSquareRefException(e,a);
            } catch (CannotGetPostcodesException e) {
                throw new CannotGetSquareException(e,"cannot get postcodes");
            } catch (CannotGetNamesException e) {
                throw new CannotGetSquareException(e,"cannot get placenames");
            }
        }
        return l;
    }
    /**
     *
     * @param arguments each arg can be either TQ300700 or E14 or 530000,170000
     * @return
     */
    private List<OsSquare> getSquaresContainingPoints(String[] arguments) throws CannotGetSquareException,InvalidSquareRefException{
        List<OsSquare> l = new ArrayList<OsSquare>(arguments.length);
        for (int i = 0; i < arguments.length; i++) {
            String a = arguments[i];
            try {
                //first look in the namefile if it exists
                Point p = getPointForName(a);
                if(p!=null){
                    if(verbose()) System.out.println("found entry in name file="+p);
                    final OsSquare square = getSquare(p.x,p.y);
                    if(square==null){
                        throw new CannotGetSquareException(null,"no square for x,y="+p.x+","+p.y);
                    }
                    l.add(square);
                }
                else if(a.indexOf(',')!=-1){ //it's a x,y
                    if(verbose()) System.out.println(a+" is x,y coordinate");
                    String[] xy = a.split(",");
                    int x=Integer.parseInt(xy[0]);
                    int y=Integer.parseInt(xy[1]);
                    final OsSquare square = getSquare(x,y);
                    if(square==null){
                        throw new CannotGetSquareException(null,"no square for x,y="+x+","+y);
                    }
                    l.add(square);
                }
                else if(a.length()==8){ //it's a landranger
                    if(verbose()) System.out.println(a+" is landranger gridref");
                    final OsSquare square = getSquare(a);
                    if(square==null){
                        throw new CannotGetSquareException(null,"no square landrander="+a);
                    }
                    l.add(square);
                }
                else{ //it's a postcode
                    if(verbose()) System.out.println(a+" is a postcode");
                    Point p1 = getPostcodeConverter().getXyMetres(a);
                    System.out.println("x,y = " + p1);
                    if(p1==null){
                        throw new CannotGetSquareException(null,"no square for postcode="+a);
                    }
                    final OsSquare square = getSquare(p1.x,p1.y);
                    if(square==null){
                        throw new CannotGetSquareException(null,"no square for x,y="+p1.x+","+p1.y);
                    }
                    l.add(square);
                }
            } catch (NumberFormatException e) {
                throw new InvalidSquareRefException(e,a);
            } catch(ArrayIndexOutOfBoundsException e){
                throw new InvalidSquareRefException(e,a);
            } catch (CannotGetPostcodesException e) {
                throw new CannotGetSquareException(e,"cannot get postcodes");
            } catch (CannotGetNamesException e) {
                throw new CannotGetSquareException(e,"cannot get placenames");
            }
        }
        return l;
    }
    Map<String,Point> nameRefs = null;
    private Point getPointForName(String name) throws CannotGetNamesException {
        if(nameRefs==null){
            try {
                String nfile=cmd.getOptionValue(namefile.getOpt());
                if(nfile==null) return null;
                File f = new File(nfile);

                LineNumberReader lnr = new LineNumberReader(new FileReader(f));
                try {
                    nameRefs = new HashMap<String, Point>();
                    String line;
                    while((line=lnr.readLine())!=null){
                        try {
                            String[] fields = line.split( "," );
                            int x=Integer.parseInt(fields[1].trim());
                            int y=Integer.parseInt(fields[2].trim());
                            //System.out.println(gc.getOsGrid(x*10,y*10));
                            nameRefs.put(fields[0].trim().toUpperCase(), new Point(x,y));
                        } catch (NumberFormatException e) {
                            if(verbose())
                                System.err.println("invalid line="+lnr.getLineNumber()+" in placenamefile file="+f
                                        +" couldn't convert to number");
                        } catch (ArrayIndexOutOfBoundsException e) {
                            if(verbose())
                                System.err.println("invalid line="+lnr.getLineNumber()+" in placenamefile file="+f
                                        +" not enough fields");
                        }
                    }
                } finally {
                    lnr.close();
                }
            } catch (NullPointerException e) {
                throw new CannotGetNamesException("couldn't get placenamefile from options",e);
            } catch (IOException e) {
                throw new CannotGetNamesException("error reading placenamefile",e);
            }
        }
        return nameRefs.get(name);
    }
    static class CannotGetNamesException extends Exception{
        public CannotGetNamesException(String message, Throwable cause) {
            super(message, cause);
        }
    }

    PostcodeConverter pc=null;
    private PostcodeConverter getPostcodeConverter() throws CannotGetPostcodesException {
        if (pc==null) {
            try {
                if(!cmd.hasOption(postcodefile.getOpt())){
                    throw new CannotGetPostcodesException("no -p option supplied to lookup postcode");
                }
                String pfile = cmd.getOptionValue(postcodefile.getOpt());
                if(pfile==null){
                    throw new CannotGetPostcodesException("cannot find postcodefile name to lookup postcode");
                }
                File f = new File(pfile);
                if(!f.exists()){
                    throw new CannotGetPostcodesException("postcodefile doesn't exist");
                }
                pc= new PostcodeConverter(f);
            } catch (IOException e) {
                if(verbose()) e.printStackTrace();
                throw new CannotGetPostcodesException("couldn't read postcodes file");
            }
        }
        return pc;
    }
    static class CannotGetPostcodesException extends Exception{
        public CannotGetPostcodesException(String message) {
            super(message);
        }
    }

    static class InvalidSquareRefException extends Exception{
        private String reference;
        public InvalidSquareRefException(Throwable cause, String reference) {
            super(cause);
            this.reference = reference;
        }
        public String getReference() {
            return reference;
        }
    }
    static class CannotGetSquareException extends Exception{
        private String reference;
        public CannotGetSquareException(Throwable cause, String reference) {
            super(cause);
            this.reference = reference;
        }

        public String getReference() {
            return reference;
        }
    }
    private static boolean verbose(){
        return cmd.hasOption(verbose.getOpt());
    }
  /*  public OsSquare getSquareFromOsXy(int osX, int osY){
        //todo: convert to imagey
        osY=convertOsYimageY(osY);
        for(OsSquare ns:squaresList){
            if(ns.contains(osX,osY)) return ns;
        }
        return null;
    }*/

    public OsSquare getSquare(int x, int y){
        for(OsSquare ns:squaresList){
            if(ns.contains(x,y)) return ns;
        }
        return null;
    }
    /**
     *
     * @param p1
     * @param p2
     * @return all the squares that intersect the smallest rectangle that contains
     * p1 and p2
     */
    public List<OsSquare> getSquares(Point p1, Point p2){
        List<OsSquare> sq = new ArrayList<OsSquare>();
        Rectangle r = new Rectangle(p1);
        r.add(p2);
        for(OsSquare ns:squaresList){
            if(r.intersects(ns)){ sq.add(ns);}
        }
        return sq;
    }
    private OsSquare getSquare(String name){
        for(OsSquare ns:squaresList){
            if(ns.getName().equals(name)) return ns;
        }
        return null;
    }
    private int convertMetresPixels(int metres, int imageWidthMetres, int imageWidthPixels){
//        System.out.println("metres = " + metres);
//        System.out.println("imageWidthMetres = " + imageWidthMetres);
//        System.out.println("imageWidthPixels = " + imageWidthPixels);
        float pixelsPerMetre=(float)imageWidthPixels/(float)imageWidthMetres;
        return (int) (metres*pixelsPerMetre);
    }
    /**
     *   NB: assumes all squares are same size
     * @param squares
     * @return a new map containing all the maps corresponding to these images
     */
    public PlanarImage createMap(List<OsSquare> squares, Rectangle boundingBoxImageMetres) throws NoSuchMapFileException {
        if(verbose()){
            System.out.println("reate map from "+squares.size()+" files");
            System.out.println("squares = " + squares);
        }
        //sort the squares by imagey then x
        /*Collections.sort(squares,new Comparator<OsSquare>() {
            public int compare(OsSquare ns1, OsSquare ns2) {
                int i=ns1.getImageY()-ns2.getImageY();
                if(i==0) i= ns1.x-ns2.x;
                return i;
            }
        });*/


        if (verbose()) {
            System.out.println("boundingBoxImageMetres = " + boundingBoxImageMetres);
        }

        //create an imagegrid
        //1.get the points
        //2.get a rectangle relative to ORIGIN that contains all those points
        //3.(optionally) grow the rectangle by buffer
        //4.create a tiledimage from that rectangle
        //? set the clip to rectangle?
        //5.draw all the touched maps ( no need to sort)


        //kudos to  jkyraz <jkyraz@TIN.IT>
        //http://archives.java.sun.com/cgi-bin/wa?A2=ind0405&L=jai-interest&F=&S=&P=13151
        TiledImage ti=null;
        Graphics2D g=null;
        OsSquare originSquare=null;

        int imageWidthMetres=0,imageWidthPixels=0;
        for(OsSquare ns:squares){
            PlanarImage pi=getImage(ns);
            if(ti==null){
                imageWidthMetres = ns.width;
                imageWidthPixels = pi.getWidth();
                int w = convertMetresPixels(boundingBoxImageMetres.width,imageWidthMetres,imageWidthPixels);
                int h = convertMetresPixels(boundingBoxImageMetres.height,imageWidthMetres,imageWidthPixels);
                int x = convertMetresPixels(boundingBoxImageMetres.x,imageWidthMetres,imageWidthPixels);
                int y = convertMetresPixels(boundingBoxImageMetres.y,imageWidthMetres,imageWidthPixels);
//                System.out.println("h = " + h);
//                System.out.println("w = " + w);
                ti = new TiledImage(x,y,w,h,0,0,pi.getSampleModel(),pi.getColorModel());
                g = ti.createGraphics();
                g.setClip(x,y,w,h);
                originSquare=ns;
            }
            AffineTransform a = new AffineTransform();
            //work out the offset of pi from originSquare
           /* int xOffMetres = ns.x-originSquare.x;
            int xOffImages = xOffMetres/ns.width;
            int xOffset=xOffImages*pi.getWidth();

            int yOffMetres = ns.getImageY()-originSquare.getImageY();
            int yOffImages = yOffMetres/ns.width;
            int yOffset=yOffImages*pi.getHeight();
            a.setToTranslation(xOffset,yOffset);*/
            int xOffset=convertMetresPixels(ns.x,imageWidthMetres,imageWidthPixels);
            int yOffset=convertMetresPixels(ns.y,imageWidthMetres,imageWidthPixels);
            a.setToTranslation(xOffset,yOffset);
            g.drawRenderedImage(pi,a);
        }
        return ti;
    }

    private static Rectangle createBoundingBox(List<OsSquare> squares, int boundinBoxExtra) {
        // boundingBoxImageMetres=getImageBoundingBox(squares);
        int minX=Integer.MAX_VALUE,minY=Integer.MAX_VALUE,maxX=-1,maxY=-1;
        for(OsSquare ns:squares){
            final int x = ns.x;
            final int imageY = ns.getImageY();
            minX=Math.min(x,minX);
            // System.out.println(ns.getName()+": "+x+"," + imageY+" w="+ns.width);
            minY=Math.min(imageY,minY);
            maxX=Math.max(ns.x+ns.width,maxX);
            maxY=Math.max(ns.getImageY()+ns.height,maxY);

        }
        Rectangle boundingBoxImageMetres = new Rectangle(new Point(minX,minY));
        boundingBoxImageMetres.add(new Point(maxX,maxY));
        boundingBoxImageMetres.grow(boundinBoxExtra,boundinBoxExtra);
        return boundingBoxImageMetres;
    }

    private String getFileName(OsSquare ns){
       // return "c:\\t\\tmp\\"+ns.getLetters()+"\\"+ns.getName()+".png";
        final String value = cmd.getOptionValue(mapsroot.getOpt());
        if(value==null) throw new IllegalArgumentException("root file not supplied");
        return value+File.separator+ns.getLetters()+File.separator+ns.getName()+".png";
    }
    private PlanarImage getImage(OsSquare ns) throws NoSuchMapFileException {
        String fileName = getFileName(ns);
        if(!new File(fileName).exists()) throw new NoSuchMapFileException(fileName);
        final RenderedOp pi = JAI.create("fileload", fileName);
        return pi;
    }
    public static class NoSuchMapFileException extends Exception   {
        private String f;
        public NoSuchMapFileException(String f) {
            super();
            this.f = f;
        }
        public String getFilename() {
            return f;
        }
    }


    public MapBuddy() {
        /*ist<OsSquare> squares = OsSquare.getSquaresContainingPoints(new Point(x,y), new Point(x1,y1));
        System.out.println("squares = " + squares);*/

        //first make a list of 5000m-square squares covering the UK
        // the grid formed by these squares is 700,000m wide and 1,300,000m tall
        //the origin is SW of cornwall

        //        this grid is from http://www.ordnancesurvey.co.uk/oswebsite/freefun/nationalgrid/nghelp1.html
        //SV is at bottomleft: 0,0
        //JM is at topright:  maxX,maxY
        //definitily: each smallsquare (of which there are 100 in lettersquare)
        // is 10km by 10km
        // therefore a letter square must be 10000*10 m^2

        squaresList = new ArrayList<OsSquare>(100*SQUARES.length);
        int smallSquareSize=SQUARE_SIZE/10;//metres == 10km

        /*int totalSquares = 100*SQUARES.length;
        int x=0,y=0;
        for(int i=0;i<totalSquares;i++){
            String name = getOsNameForSquare(x,y,smallSquareSize,smallSquareSize);
            OsSquare ns = new OsSquare(x,y,smallSquareSize ,smallSquareSize ,name);
            squaresList.add(ns);
        }*/

        int y=0;

        for(String[] ro:SQUARES){
            //  String[] ro=SQUARES[j];
            int x=0;
            for(String name:ro){
                //each of these big squares is divided into 100 5000m^2 squares
                for(int smallY=0;smallY<10;smallY++){
                    for(int smallX=0;smallX<10;smallX++){
                        int relativeX=smallY*smallSquareSize;
                        int relativeY=smallX*smallSquareSize;
                        String sName = name
                                +getOsName(relativeX,3)
                                +getOsName(relativeY,3);
                        //String sName = name+ smallX+"00"+smallY+"00";
                        OsSquare ns = new OsSquare(
                                x+relativeX
                                ,y+relativeY
                                ,smallSquareSize
                                ,smallSquareSize
                                ,sName);
                        squaresList.add(ns);
                    }
                }
                x+=SQUARE_SIZE;
            }
            y+=SQUARE_SIZE;
        }

        //get all the TQ squares:
        /* for(OsSquare ns:squaresList){
        if(ns.getName().startsWith("TQ")){
        System.out.println("ns = " + ns);
        // System.out.println(ns.getOsGridRef());
        }
        }*/
    }



    private String getOsName(int metres, int figures){
        String m = String.valueOf(metres);
        if(m.length()<figures){
            StringBuffer sb = new StringBuffer(figures);
            sb.append(m);
            while(sb.length()<figures) sb.insert(0,"0");
            return sb.toString();
        }
        return m.substring(0,figures);
    }

    public static class OsSquare extends Rectangle{
        private String name;

        public OsSquare(int x, int y, int width, int height, String name) {
            super(x, y, width, height);
            this.name = name;
        }
        public String getName() {
            return name;
        }
        public String getLetters(){
            return name.substring(0,2);
        }
        public String toString() {
            return getName()+" ("+x+","+y+")";
        }

        public int getImageRow(){
            int squareCount=OS_GRID_HEIGHT/height;
            return getImageY()/squareCount;
        }
        public int getImageColumn(){
            int squareCount=OS_GRID_WIDTH/width;
            return x/squareCount;
        }


        public int getImageY(){
            return OS_GRID_HEIGHT-SQUARE_SIZE-y;
        }


    }
    /**
         * converts y in image-coord system to OS coord system
         * //the OS grid has 0,0 at the bottom left with y increasing up
         // whereas we use top-left with y increasing down
         * @return
         */
   /* private static int convertOsYimageY(int osY){
        return OS_GRID_HEIGHT-osY;
    }*/




}
