package uk.co.hcsoftware.images.gui.map;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.prefs.Preferences;
import java.io.File;

/**
 * gui equivalent of mainclass.
 * started writing using FormDesigner, but became frustrated by all the pointing and clicking.
 * Doesn't really suit things where you want to roll a custom control (such as filepanel)
 * and you have to go into 'gui editor' mode to edit the gui then coder mode to write the behaviour, rather than doing
 * both simultaneously. Gave up after 10 mins or so and started writing code.
 * Gave that up too, as was more work than I had envisaged.. will finish later
 */
public class MapForm extends JPanel{
    public MapForm() {
        setLayout(new BorderLayout(4,4));
        setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
        JTabbedPane jtp = new JTabbedPane();
        add(jtp);
        jtp.addTab("map settings", new MapSettingsPanel());
        jtp.addTab("file locations", new FilesPanel());
        JPanel buttonPan = new JPanel(new FlowLayout(FlowLayout.RIGHT,4,2));
        final JButton make=new JButton("make map");
        final JButton save=new JButton("save settings");
        ActionListener al = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                Object o = e.getSource();
                if(o==make){
                    try {
                        makeMap();
                    } catch (InvalidArgException e1) {
                        JOptionPane.showMessageDialog(MapForm.this,e1.getArgName()+" is invalid" +
                                "\n"+e1.getMessage()+"\n" +
                                "(value was "+e1.getArgValue()+")");
                    }
                }
                else saveSettings();
            }
        };
        save.addActionListener(al);
        make.addActionListener(al);
        buttonPan.add(save);
        buttonPan.add(make);
        add(buttonPan,BorderLayout.SOUTH);
        readSettings();
    }

    private void makeMap() throws InvalidArgException {
        //todo set settings from controls, validate and call run
        MapFactory mf = new MapFactory();
        mf.setChop(get(chopX.getText()),get(chopY.getText()));
        mf.setDrawLines(lines.isSelected());
        mf.setDrawRings(circles.isSelected());
        if(scale.isSelected()){
            int sw=get(scaleW.getText());
            int sh=get(scaleH.getText());
            if(sw==-1&&sh==-1){
                throw new InvalidArgException("scale",sw+","+sh," at least 1 must be >-1");
            }
          //  mf.setScaleValue();

        }


       // mf.setMapsRoot(get(mapsRoot.getText()));
       // mf.set
    }
    Preferences p = Preferences.userNodeForPackage(MapForm.class);
    private void saveSettings() {
        p.putBoolean("circles",circles.isSelected());
        p.putBoolean("lines",lines.isSelected());
        p.putBoolean("display",display.isSelected());
        p.putBoolean("writeFile",writeFile.isSelected());
        p.putBoolean("chop",chop.isSelected());
        p.putBoolean("scale",scale.isSelected());

        p.putInt("margin",get(margin.getText()));
        p.putInt("scaleW",get(scaleW.getText()));
        p.putInt("scaleH",get(scaleH.getText()));
        p.putInt("chopY",get(chopY.getText()));
        p.putInt("chopX",get(chopX.getText()));

        p.put("mapFile",mapFile.getText());
        p.put("mapsRoot",mapsRoot.getText());
        p.put("mapsScan",mapsScan.getText());
        p.put("placeNames",placeNames.getText());
        p.put("postcodes",postcodes.getText());
    }
    private void readSettings(){
        circles.setSelected(p.getBoolean("circles",true));
        lines.setSelected(p.getBoolean("lines",true));
        display.setSelected(p.getBoolean("display",true));
        writeFile.setSelected(p.getBoolean("writeFile",true));
        chop.setSelected(p.getBoolean("chop",true));
        scale.setSelected(p.getBoolean("scale",true));
        circles.setSelected(p.getBoolean("circles",true));

        margin.setText(get(p.getInt("margin",-1)));
        scaleW.setText(get(p.getInt("scaleW",-1)));
        scaleH.setText(get(p.getInt("scaleH",-1)));
        chopY.setText(get(p.getInt("chopY",-1)));
        chopX.setText(get(p.getInt("chopX",-1)));

        mapFile.setText(p.get("mapFile",""));
        mapsRoot.setText(p.get("mapsRoot",""));
        mapsScan.setText(p.get("mapsScan",""));
        placeNames.setText(p.get("placeNames",""));
        postcodes.setText(p.get("postcodes",""));
    }


    private static int get(String val){
        try {
            return Integer.parseInt(val);
        } catch (NumberFormatException e) {
            return -1;
        }
    }
    private static String get(int i){
        return i==-1?"":String.valueOf(i);
    }

    //todo: add scalevalue control (e.g. scale to 1/n)
    JCheckBox circles=new JCheckBox(),lines=new JCheckBox(),display=new JCheckBox();
    JCheckBox writeFile=new JCheckBox();
    JCheckBox chop=new JCheckBox(),scale=new JCheckBox();
    JTextField scaleW=new JTextField(),scaleH=new JTextField();
    JTextField chopX=new JTextField(),chopY=new JTextField();

    JTextField margin=new JTextField();
    JTextField mapFile=new JTextField();

    JTextField mapsRoot=new JTextField(),mapsScan=new JTextField(),placeNames=new JTextField(),postcodes=new JTextField();


    class MapSettingsPanel extends JPanel{
        public MapSettingsPanel() {
            setLayout(new FlowLayout());
            JPanel jp = new JPanel(new GridLayout(4,2,0,4));
            //todo: lay out the controls
           /* add(jp);
            jp.add(new JLabel("maps root directory:"));
            jp.add(new FileControl(mapsRoot,JFileChooser.DIRECTORIES_ONLY));

            jp.add(new JLabel("scan directory:"));
            jp.add(new FileControl(mapsScan,JFileChooser.DIRECTORIES_ONLY));

            jp.add(new JLabel("place name file:"));
            jp.add(new FileControl(placeNames,JFileChooser.FILES_ONLY));

            jp.add(new JLabel("postcodes file:"));
            jp.add(new FileControl(postcodes,JFileChooser.FILES_ONLY));*/
        }
    }
    class FilesPanel extends JPanel{
        public FilesPanel() {
            super(new BorderLayout());
           // setLayout(new FlowLayout());
            JPanel jp = new JPanel(new GridLayout(4,2,4,4));
            add(jp);
            jp.add(new JLabel("maps root directory:"));
            jp.add(new FileControl(mapsRoot,JFileChooser.DIRECTORIES_ONLY));

            jp.add(new JLabel("scan directory:"));
            jp.add(new FileControl(mapsScan,JFileChooser.DIRECTORIES_ONLY));

            jp.add(new JLabel("place name file:"));
            jp.add(new FileControl(placeNames,JFileChooser.FILES_ONLY));

            jp.add(new JLabel("postcodes file:"));
            jp.add(new FileControl(postcodes,JFileChooser.FILES_ONLY));
        }
    }
    class FileControl extends JPanel implements ActionListener {
        private final int selectionMode;
        private JTextField jtf;

        public FileControl(JTextField jtf, int selectionMode ) {
            super(new BorderLayout(2,0));
            this.selectionMode = selectionMode;
            this.jtf=jtf;
            add(new JScrollPane(jtf));
            JButton jb = new JButton("...");
            add(jb,BorderLayout.EAST);
            jb.addActionListener(this);
        }

        public void actionPerformed(ActionEvent e) {
            jfc.setApproveButtonText("Select");
            jfc.setFileSelectionMode(selectionMode);
            String text = jtf.getText();
            if(text.length()>0){
                File f = new File(text);
                jfc.setSelectedFile(f);
            }
            if(JFileChooser.APPROVE_OPTION==jfc.showOpenDialog(this)){
                jtf.setText(jfc.getSelectedFile().getAbsolutePath());
            }
        }
    }
    JFileChooser jfc = new JFileChooser(System.getProperty("user.home"));
}
