package uk.co.hcsoftware.images.gui.map;

import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;
import javax.media.jai.RenderedOp;
import java.awt.*;
import java.io.File;
import java.util.logging.Level;
import java.util.logging.Logger;

public class MapTile extends Rectangle{
    private static final Logger log = Logger.getLogger(MapTile.class.getName());
    private final File imageFile;

    //from topleft of uk
    public MapTile(int xMetres, int yMetres, int wMetres, int hMetres, File imageFile) {
        super(xMetres,yMetres,wMetres,hMetres);
            this.imageFile = imageFile;
    }


    public PlanarImage getImage() throws NoFileForTileException {
        if(!imageFile.exists()){
            throw new NoFileForTileException(imageFile,this);
        }
        String fileName = imageFile.getAbsolutePath();
        log.log(Level.INFO,"loading image from "+fileName);
        final RenderedOp pi = JAI.create("fileload", fileName);
        return pi;
    }

    public String toString() {
        return super.toString()+" file="+imageFile;
    }
}