package uk.co.hcsoftware.images.gui.map;

import java.awt.*;
import java.util.ArrayList;
import java.util.List;

public class OsGrid {

    public OsGrid() {
        //1.build a list of maptiles for all the os5000 files we have (or all there are in theory)
        //2. have main
        int y=0;
        for(String[] ro: LANDRANGERSQUARES){
            int x=0;
            for(String letter: ro){
                letters.add(new Letter(letter,x,y));
                x+=LETTERWIDTH_METRES;
            }
            y+=LETTERWIDTH_METRES;
        }
        /* for(Letter l:letters){
        log.log(Level.INFO,l);
        }*/
    }

    public static final int LETTERWIDTH_METRES=100000;

    private static final String[][] LANDRANGERSQUARES = new String[][]{
        new String[]{"SV", "SW", "SX", "SY", "SZ", "TV", "TW"}
        , new String[]{"SQ", "SR", "SS", "ST", "SU", "TQ", "TR"}
        , new String[]{"SL", "SM", "SN", "SO", "SP", "TL", "TM"}
        , new String[]{"SF", "SG", "SH", "SJ", "SK", "TF", "TG"}
        , new String[]{"SA", "SB", "SC", "SD", "SE", "TA", "TB"}
        , new String[]{"NV", "NW", "NX", "NY", "NZ", "OV", "OW"}
        , new String[]{"NQ", "NR", "NS", "NT", "NU", "OQ", "OR"}
        , new String[]{"NL", "NM", "NN", "NO", "NP", "OL", "OM"}
        , new String[]{"NF", "NG", "NH", "NJ", "NK", "OF", "OG"}
        , new String[]{"NA", "NB", "NC", "ND", "NE", "OA", "OB"}
        , new String[]{"HV", "HW", "HX", "HY", "HZ", "JV", "JW"}
        , new String[]{"HQ", "HR", "HS", "HT", "HU", "JQ", "JR"}
        , new String[]{"HL", "HM", "HN", "HO", "HP", "JL", "JM"}
    };
    public List<String> getSquares(){
        List<String> squares = new ArrayList<String>();
        for(String[] s: LANDRANGERSQUARES){
            for(String ss:s){
                squares.add(ss);
            }
        }
        return squares;
    }
    /**
     *
     * @param p point in metres relative to top-left corner of UK
     * @return
     */
    public Letter getLetter(Point p){
        for(Letter l:letters){
            if(l.contains(p)) return l;
        }
        return null;
    }

    public List<Letter> getLetters() {
        return letters;
    }

    public Letter getLetter(String name){
        for(Letter l:letters){
            if(l.getName().equals(name)) return l;
        }
        return null;
    }
    List<Letter> letters=new ArrayList<Letter>();

    /**
     *
     * @return  pMetresRelativeTL
     */
    public Point getTranslatedPoint(Point pMetresRelativeBL) {
        Point p = new Point(pMetresRelativeBL);
        //  p.y=(LANDRANGERSQUARES.length*LETTERWIDTH_METRES)-p.y;
        return p;
    }
    public Point getPoint(String letters,int xMetres,int yMetres){
        Letter l = getLetter(letters);
        return new Point(l.x+xMetres,l.y+yMetres);
    }

    public static class Letter extends Rectangle{
        private String name;
        public Letter(String name,int x, int y) {
            super(x, y, LETTERWIDTH_METRES, LETTERWIDTH_METRES);
            this.name = name;
        }
        public Point getTopLeftMetres(){
            return new Point(x,y);
        }
        public Point getBottomLeftMetres(){
            return new Point(x,y+height);
        }

        public String getName() {
            return name;
        }

        public String toString() {
            return name+" ("+x+","+y+")";
        }
    }
}
