package uk.co.hcsoftware.images.test;

import junit.framework.TestCase;
import uk.co.hcsoftware.images.web.ElementEncoder;

import java.util.List;
import java.util.ArrayList;
import java.util.Arrays;


/**
 * Title: ElementEncoderTest
 * Copyright:    Copyright (c) 12-Jan-2006
 *
 * @author spurlinn
 */
public class ElementEncoderTest extends TestCase{
    private ElementEncoder ee = new ElementEncoder();

    public void testSimple(){
        assertEquals("<a href=\"hello\"/>", ee.generateUrl("a",ElementEncoder.ElementType.simple,"href","hello"));

        String imageref="id="+1234+"&gallery="+5678;
        String url=  "<img class=\"fullsize\"" +
               " src=\"load?"+imageref+"\"" +
               "/>" ;
        assertEquals(url, ee.generateUrl("img",ElementEncoder.ElementType.simple
        ,"class","fullsize"
        ,"src", "load?"+imageref

        ));

    }
    public void testComplexOpen(){
        assertEquals("<a href=\"hello\">", ee.generateUrl("a",ElementEncoder.ElementType.complexOpen,"href","hello"));



    }
    public void testComplexClose(){
        assertEquals("</a>", ee.generateUrl("a",ElementEncoder.ElementType.complexClose,"href","hello"));
    }

    public void testComplex(){
        String imageRef="id="+123+"&gallery="+46;
        StringBuilder sb = new StringBuilder();
        sb.append("<a href=\"view_image.jspx?"+imageRef+"\">");
        sb.append("<img class=\"thumb\"");
        sb.append(" src=\"load?thumb=true&"+imageRef+"\"");
       // if(hasBlurb()){
            String tooltip = "tooltip";
            sb.append(" title=\"");
            sb.append(tooltip);
            sb.append("\"");
       // }
        sb.append("/>");
        sb.append( "</a>");
        String url= sb.toString();
        StringBuilder url2 = new StringBuilder();
        url2.append(ee.generateUrl("a",ElementEncoder.ElementType.complexOpen,
                "href","view_image.jspx?"+imageRef
        ));
        List<String> imgAttributes = new ArrayList<String>();
        imgAttributes.addAll(Arrays.asList(
                new String[]{
                     "class","thumb"
                     ,"src","load?thumb=true&"+imageRef
                }
        ));
        imgAttributes.add("title");
        imgAttributes.add("tooltip");
        url2.append(ee.generateUrl("img",ElementEncoder.ElementType.simple
            ,imgAttributes.toArray(new String[imgAttributes.size()])
        ));
        url2.append(ee.generateUrl("a",ElementEncoder.ElementType.complexClose,
                (String[])null
        ));
        assertEquals(url,url2);
    }
}
