package uk.co.hcsoftware.images.tools;

import javax.media.jai.JAI;
import javax.media.jai.RegistryMode;
import javax.media.jai.OperationRegistry;
import java.util.logging.Logger;
import java.util.logging.Level;

/**
 * Title: ListJaiOperations
 *
 * @author spurlinn
 * @see http://java.sun.com/products/java-media/jai/forDevelopers/jai-apidocs/index.html
 */

/**
 * lists available JAI ops
 */
public class ListJaiOperations {
    private static final Logger log = Logger.getLogger(ListJaiOperations.class.getName());
    public ListJaiOperations() {
        or = JAI.getDefaultInstance().getOperationRegistry();
        String[] modeNames = RegistryMode.getModeNames();
        String[] descriptorNames;

        for (int i = 0; i < modeNames.length; i++) {
            log.log(Level.INFO,"For registry mode: " + modeNames[i]);

            descriptorNames = or.getDescriptorNames(modeNames[i]);
            for (int j = 0; j < descriptorNames.length; j++) {
                System.out.print("\tRegistered Operator: ");
                log.log(Level.INFO,descriptorNames[j]);
            }
        }
    }

    public static void main(String[] args) {
        new ListJaiOperations();
    }

    private OperationRegistry or;
}
