package uk.co.hcsoftware.images.tools;

import com.sun.media.jai.codec.FileSeekableStream;
import ns.TaskTimer;

import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.awt.image.renderable.ParameterBlock;
import java.io.File;
import java.io.IOException;
import java.util.logging.Logger;
import java.util.logging.Level;


/**
 * Title: Transparentizer
 * Copyright:    Copyright (c) 26-Jul-2005
 * Company:      Barclays Capital
 *
 * @author spurlinn
 */
public class Transparentizer {
   private static final Logger log = Logger.getLogger(Transparentizer.class.getName());
    public static void main(String[] args) {
        try {
            new Transparentizer().processFile(new File(args[0]),args[1]);
        } catch (Exception e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
    }


    private void processFile(File inFile, String outFile) {

        FileSeekableStream stream = null;
        try {
            stream = new FileSeekableStream(inFile);
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(0);
        }
        final TaskTimer tt = new TaskTimer();
        PlanarImage pi = JAI.create("stream", stream);

        BufferedImage bufferedImage = pi.getAsBufferedImage();
        int pixelsChanged=0;

        int w = bufferedImage.getWidth(null);
        int h = bufferedImage.getHeight(null);
        int[] rgbs = new int[w*h];
      //  int[] blues = new int[0xff<<24];
        final int val =0;// new Color(0,0,0,0).getRGB();
        bufferedImage.getRGB(0, 0, w, h, rgbs, 0, w);
        for (int i = 0; i < rgbs.length; i++) {
            int pixel = rgbs[i];
            if(pixel==Color.WHITE.getRGB()){
                rgbs[i]=val;
                pixelsChanged++;
              /*  if(i+1<rgbs.length){
                    blues[rgbs[i+1]]++;
                }*/
            }
        }
        bufferedImage.setRGB(0, 0, w, h, rgbs, 0, w);
        log.log(Level.INFO,"pixelsChanged = " + pixelsChanged);
      /*  int maxBlue=0;
        int maxBlueIdx=0;
        for (int i = 0; i < blues.length; i++) {
            int blue = blues[i];
            if(blue>maxBlue){
                maxBlue=blue;
                maxBlueIdx=i;
            }
        }
        log.log(Level.INFO,"maxBlue = " + maxBlueIdx);*/
        pi = PlanarImage.wrapRenderedImage(bufferedImage);

        ParameterBlock pb = new ParameterBlock();
        pb.addSource(pi);
        pb.add(outFile);
        pb.add("png");
        pb.add(null);
        //  pb.add(true);
        JAI.create("filestore", pb, null);
        log.log(Level.INFO,"wrote file= " + outFile+ " took "+tt.stopString());
    }

}
