package uk.co.hcsoftware.images.web;

import java.util.logging.Logger;
import java.util.logging.Level;
import java.io.*;


/**
 * Title: BlurbReader
 * Copyright:    Copyright (c) 16-Nov-2005
 *
 * @author spurlinn
 */
public class BlurbReader {
    public static final Logger log = Logger.getLogger(BlurbReader.class.getName());
    private String blurb=null;
    public BlurbReader(File blurbFile) {
        if(blurbFile.exists()){
            try {
log.info("reading blurbfile="+blurbFile);
                Reader r = new BufferedReader(new InputStreamReader(new FileInputStream(blurbFile),"UTF-8"));
                StringBuilder sb = new StringBuilder((int) blurbFile.length());
                char[] buf = new char[256];
                int i;
                while((i=r.read(buf,0,buf.length))!=-1){
                    sb.append(buf,0,i);
                }
                r.close();
                blurb=sb.toString();
            } catch (IOException e) {
                log.log(Level.WARNING, "error reading blurb", e);
            }
        }
	else log.info("no blurbfile="+blurbFile);
    }
    public boolean blurbExists(){
        return blurb!=null;
    }
    public String getBlurb(){
        return blurb;
    }
}
