package uk.co.hcsoftware.images.web;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.util.logging.Logger;
import java.util.logging.Level;


public class ImageLoaderServlet extends HttpServlet{
    final static Logger log = Logger.getLogger(ImageLoaderServlet.class.getName());

     protected void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
         String id = req.getParameter("id");
         String gallery = req.getParameter( "gallery");
         String thumb=req.getParameter("thumb");
         try {
             GalleryIndex gi = GalleryIndex.getInstance();
             Gallery g = gi.getGallery(gallery);
             Image i = g.getImage(id);
             if("true".equals(thumb)){
                 writeFile(res,i.getThumb());
             }
             else writeFile(res,i.getFull());
         } catch (NoSuchGalleryException e) {
             log.info("gallery not found="+e.getId());
             throw new ServletException("no such gallery!");
         } catch (NoSuchImageException e) {
             log.info("gallery not found="+e.getId());
             throw new ServletException("no such images!");
         }
     }

    private void writeFile(HttpServletResponse res, File thumb) throws ServletException {
        try {
            OutputStream os = res.getOutputStream();
            InputStream is = new BufferedInputStream(new FileInputStream(thumb));
            byte[] buf = new byte[256];
            int i;
            while((i=is.read(buf))!=-1){
                os.write(buf,0,i);
            }
            os.flush();
        } catch (IOException e) {
            log.log(Level.WARNING,"error writing images file to response",e);
            throw new ServletException("couldn't find images!");
        }
    }
}
