package uk.co.hcsoftware.images.web;

import javax.servlet.http.HttpServletRequest;


public class SlideHelper {
    private int imageNumber=1; //WARNING imagenumber is 1-based (so the urls look friendly)
    private Gallery g;

    public SlideHelper(HttpServletRequest request) throws NoSuchGalleryException {
        //request should have a number parameter and a gallery parameter
        g = GalleryIndex.getInstance().getGallery(request.getParameter("gallery"));
        String imageParam = request.getParameter("number");
        try {
            if(imageParam!=null && !"".equals(imageParam.trim())){
                imageNumber=Integer.parseInt(imageParam);
            }
        } catch (NumberFormatException e) {;}
    }
    public Image getCurrentImage() throws NoSuchImageException {
        return g.getImage(imageNumber-1);
    }
    public Gallery getGallery(){
        return g;
    }
    public String getNextHref(){
       return getHref("next",imageNumber+1);
    }
    public String getPreviousHref(){
       return getHref("previous",imageNumber-1);
    }
    public String getLastHref(){
        return getHref("last",g.getImageCount());
    }
    public String getFirstHref(){
        return getHref("first",1);
    }
    public int getImageCount(){
        return g.getImageCount();
    }
    public int getImageNumber(){
        return imageNumber;
    }
    /**
     * checks imageNumber is valid, if so returns and <a href="">text</a> else returns text
     * @param hrefText
     * @param imageNumber
     * @return
     */
    private String getHref(String hrefText, int imageNumber){
       if(imageNumber<1 || imageNumber>g.getImageCount() || imageNumber==this.imageNumber){
            //no such image, so don't send an href, just return plain text
            return  hrefText ;
        }
        else return getHref(g,hrefText,imageNumber);
    }
    public static String getHref(Gallery g, String hrefText, int imageNumber){
        return "<a href=\""+getRef(g,imageNumber)+"\" class=\"imagemovement\">"+ hrefText + "</a>";
    }
    private static String getRef(Gallery g, int i) {
        return "view_slide.jspx?gallery="+g.getId()+"&number="+i;
    }
    public static String getSlideshowHref(Gallery g){
        return getHref(g,"slide show",1);
    }

}
